summaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
Diffstat (limited to 'tools')
-rw-r--r--tools/check_for_upgrade.sh71
-rwxr-xr-xtools/upgrade.sh101
2 files changed, 158 insertions, 14 deletions
diff --git a/tools/check_for_upgrade.sh b/tools/check_for_upgrade.sh
index e87da3487..157b0cce2 100644
--- a/tools/check_for_upgrade.sh
+++ b/tools/check_for_upgrade.sh
@@ -3,22 +3,70 @@ if [[ -f ~/.zsh-update && ! -f "${ZSH_CACHE_DIR}/.zsh-update" ]]; then
mv ~/.zsh-update "${ZSH_CACHE_DIR}/.zsh-update"
fi
+# Get user's update preferences
+#
+# Supported update modes:
+# - prompt (default): the user is asked before updating when it's time to update
+# - auto: the update is performed automatically when it's time
+# - reminder: a reminder is shown to the user when it's time to update
+# - disabled: automatic update is turned off
+zstyle -s ':omz:update' mode update_mode || update_mode=prompt
+
+# Support old-style settings
+[[ "$DISABLE_UPDATE_PROMPT" != true ]] || update_mode=auto
+[[ "$DISABLE_AUTO_UPDATE" != true ]] || update_mode=disabled
+
# Cancel update if:
# - the automatic update is disabled.
# - the current user doesn't have write permissions nor owns the $ZSH directory.
# - git is unavailable on the system.
-if [[ "$DISABLE_AUTO_UPDATE" = true ]] \
+if [[ "$update_mode" = disabled ]] \
|| [[ ! -w "$ZSH" || ! -O "$ZSH" ]] \
|| ! command -v git &>/dev/null; then
+ unset update_mode
return
fi
-
function current_epoch() {
zmodload zsh/datetime
echo $(( EPOCHSECONDS / 60 / 60 / 24 ))
}
+function is_update_available() {
+ local branch
+ branch=${"$(git -C "$ZSH" config --local oh-my-zsh.branch)":-master}
+
+ local remote remote_url remote_repo
+ remote=${"$(git -C "$ZSH" config --local oh-my-zsh.remote)":-origin}
+ remote_url=$(git -C "$ZSH" config remote.$remote.url)
+
+ local repo
+ case "$remote_url" in
+ https://github.com/*) repo=${${remote_url#https://github.com/}%.git} ;;
+ git@github.com:*) repo=${${remote_url#git@github.com:}%.git} ;;
+ *)
+ # If the remote is not using GitHub we can't check for updates
+ # Let's assume there are updates
+ return 0 ;;
+ esac
+
+ # If the remote repo is not the official one, let's assume there are updates available
+ [[ "$repo" = ohmyzsh/ohmyzsh ]] || return 0
+ local api_url="https://api.github.com/repos/${repo}/commits/${branch}"
+
+ # Get local and remote HEADs and compare them. If we can't get either assume there are updates
+ local local_head remote_head
+ local_head=$(git -C "$ZSH" rev-parse $branch 2>/dev/null) || return 0
+
+ remote_head=$(curl -fsSL -H 'Accept: application/vnd.github.v3.sha' $api_url 2>/dev/null) \
+ || remote_head=$(wget -O- --header='Accept: application/vnd.github.v3.sha' $api_url 2>/dev/null) \
+ || remote_head=$(HTTP_ACCEPT='Accept: application/vnd.github.v3.sha' fetch -o - $api_url 2>/dev/null) \
+ || return 0
+
+ # Compare local and remote HEADs
+ [[ "$local_head" != "$remote_head" ]]
+}
+
function update_last_updated_file() {
echo "LAST_EPOCH=$(current_epoch)" >! "${ZSH_CACHE_DIR}/.zsh-update"
}
@@ -56,7 +104,8 @@ function update_ohmyzsh() {
# the shell actually exits what it's running.
trap "
ret=\$?
- unset -f current_epoch update_last_updated_file update_ohmyzsh 2>/dev/null
+ unset update_mode
+ unset -f current_epoch is_update_available update_last_updated_file update_ohmyzsh 2>/dev/null
command rm -rf '$ZSH/log/update.lock'
return \$ret
" EXIT INT QUIT
@@ -68,15 +117,22 @@ function update_ohmyzsh() {
fi
# Number of days before trying to update again
- epoch_target=${UPDATE_ZSH_DAYS:-13}
+ zstyle -s ':omz:update' frequency epoch_target || epoch_target=${UPDATE_ZSH_DAYS:-13}
# Test if enough time has passed until the next update
if (( ( $(current_epoch) - $LAST_EPOCH ) < $epoch_target )); then
return
fi
- # Ask for confirmation before updating unless disabled
- if [[ "$DISABLE_UPDATE_PROMPT" = true ]]; then
+ # Check if there are updates available before proceeding
+ if ! is_update_available; then
+ return
+ fi
+
+ # Ask for confirmation before updating unless in auto mode
+ if [[ "$update_mode" = auto ]]; then
update_ohmyzsh
+ elif [[ "$update_mode" = reminder ]]; then
+ echo "[oh-my-zsh] It's time to update! You can do that by running \`omz update\`"
else
# input sink to swallow all characters typed before the prompt
# and add a newline if there wasn't one after characters typed
@@ -92,3 +148,6 @@ function update_ohmyzsh() {
esac
fi
}
+
+unset update_mode
+unset -f current_epoch is_update_available update_last_updated_file update_ohmyzsh
diff --git a/tools/upgrade.sh b/tools/upgrade.sh
index 1424d1433..7642858fe 100755
--- a/tools/upgrade.sh
+++ b/tools/upgrade.sh
@@ -15,11 +15,98 @@ cd "$ZSH"
# Use colors, but only if connected to a terminal
# and that terminal supports them.
+# The [ -t 1 ] check only works when the function is not called from
+# a subshell (like in `$(...)` or `(...)`, so this hack redefines the
+# function at the top level to always return false when stdout is not
+# a tty.
+if [ -t 1 ]; then
+ is_tty() {
+ true
+ }
+else
+ is_tty() {
+ false
+ }
+fi
+
+# This function uses the logic from supports-hyperlinks[1][2], which is
+# made by Kat Marchán (@zkat) and licensed under the Apache License 2.0.
+# [1] https://github.com/zkat/supports-hyperlinks
+# [2] https://crates.io/crates/supports-hyperlinks
+#
+# Copyright (c) 2021 Kat Marchán
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+supports_hyperlinks() {
+ # $FORCE_HYPERLINK must be set and be non-zero (this acts as a logic bypass)
+ if [ -n "$FORCE_HYPERLINK" ]; then
+ [ "$FORCE_HYPERLINK" != 0 ]
+ return $?
+ fi
+
+ # If stdout is not a tty, it doesn't support hyperlinks
+ is_tty || return 1
+
+ # DomTerm terminal emulator (domterm.org)
+ if [ -n "$DOMTERM" ]; then
+ return 0
+ fi
+
+ # VTE-based terminals above v0.50 (Gnome Terminal, Guake, ROXTerm, etc)
+ if [ -n "$VTE_VERSION" ]; then
+ [ $VTE_VERSION -ge 5000 ]
+ return $?
+ fi
+
+ # If $TERM_PROGRAM is set, these terminals support hyperlinks
+ case "$TERM_PROGRAM" in
+ Hyper|iTerm.app|terminology|WezTerm) return 0 ;;
+ esac
+
+ # kitty supports hyperlinks
+ if [ "$TERM" = xterm-kitty ]; then
+ return 0
+ fi
+
+ # Windows Terminal or Konsole also support hyperlinks
+ if [ -n "$WT_SESSION" ] || [ -n "$KONSOLE_VERSION" ]; then
+ return 0
+ fi
+
+ return 1
+}
+
+fmt_link() {
+ # $1: text, $2: url, $3: fallback mode
+ if supports_hyperlinks; then
+ printf '\033]8;;%s\a%s\033]8;;\a\n' "$2" "$1"
+ return
+ fi
+
+ case "$3" in
+ --text) printf '%s\n' "$1" ;;
+ --url|*) fmt_underline "$2" ;;
+ esac
+}
+
+fmt_underline() {
+ is_tty && printf '\033[4m%s\033[24m\n' "$*" || printf '%s\n' "$*"
+}
+
setopt typeset_silent
typeset -a RAINBOW
-typeset RED GREEN YELLOW BLUE BOLD DIM UNDER RESET
-if [ -t 1 ]; then
+if is_tty; then
RAINBOW=(
"$(printf '\033[38;5;196m')"
"$(printf '\033[38;5;202m')"
@@ -35,8 +122,6 @@ if [ -t 1 ]; then
YELLOW=$(printf '\033[33m')
BLUE=$(printf '\033[34m')
BOLD=$(printf '\033[1m')
- DIM=$(printf '\033[2m')
- UNDER=$(printf '\033[4m')
RESET=$(printf '\033[0m')
fi
@@ -104,10 +189,10 @@ if git pull --rebase --stat $remote $branch; then
printf '%s\____/%s_/ /_/ %s /_/ /_/ /_/%s\__, / %s /___/%s____/%s_/ /_/ %s\n' $RAINBOW $RESET
printf '%s %s %s %s /____/ %s %s %s %s\n' $RAINBOW $RESET
printf '\n'
- printf "${BLUE}%s${RESET}\n" "$message"
- printf "${BLUE}${BOLD}%s ${UNDER}%s${RESET}\n" "To keep up with the latest news and updates, follow us on Twitter:" "https://twitter.com/ohmyzsh"
- printf "${BLUE}${BOLD}%s ${UNDER}%s${RESET}\n" "Want to get involved in the community? Join our Discord:" "https://discord.gg/ohmyzsh"
- printf "${BLUE}${BOLD}%s ${UNDER}%s${RESET}\n" "Get your Oh My Zsh swag at:" "https://shop.planetargon.com/collections/oh-my-zsh"
+ printf "${BLUE}%s${RESET}\n\n" "$message"
+ printf "${BLUE}${BOLD}%s %s${RESET}\n" "To keep up with the latest news and updates, follow us on Twitter:" "$(fmt_link @ohmyzsh https://twitter.com/ohmyzsh)"
+ printf "${BLUE}${BOLD}%s %s${RESET}\n" "Want to get involved in the community? Join our Discord:" "$(fmt_link "Discord server" https://discord.gg/ohmyzsh)"
+ printf "${BLUE}${BOLD}%s %s${RESET}\n" "Get your Oh My Zsh swag at:" "$(fmt_link "Planet Argon Shop" https://shop.planetargon.com/collections/oh-my-zsh)"
else
ret=$?
printf "${RED}%s${RESET}\n" 'There was an error updating. Try again later?'